#ifndef SPI_CONFIG_H
#define SPI_CONFIG_H



/* ********************************SPI ***********************************/
#define NEED_SPI_STANDART
#define NEED_SPI_SHORTYS
#define NEED_SPI_DIRECTS
#define NEED_SPI_EXTENDED




/***** SPI DEFINITIONS**************************/
#define SPDR 0x0f
#define SPSR 0x0e
#define SPCR 0x0d
#define DDR_SPI 0x17
#define DD_SS 4
#define DD_MOSI 5
#define DD_MISO 6
#define DD_SCK 7

/* SPDR - SPI Data Register*/
#define SPDR0 0	/* SPI Data Register bit 0*/
#define SPDR1	 1	/* SPI Data Register bit 1*/
#define SPDR2	 2	/* SPI Data Register bit 2*/
#define SPDR3	 3	/* SPI Data Register bit 3*/
#define SPDR4	 4	/* SPI Data Register bit 4*/
#define SPDR5	 5	/* SPI Data Register bit 5*/
#define SPDR6	 6	/* SPI Data Register bit 6*/
#define SPDR7	 7	/* SPI Data Register bit 7*/

/* SPSR - SPI Status Register*/
#define SPI2X 0	/* Double SPI Speed Bit*/

#define WCOL 6	/* Write Collision Flag*/
#define SPIF 7	/* SPI Interrupt Flag*/

/* SPCR - SPI Control Register*/
#define SPR0 0	 /*SPI Clock Rate Select 0*/
#define SPR1 1	 /*SPI Clock Rate Select 1*/
#define CPHA 2	 /*Clock Phase*/
#define CPOL 3	 /*Clock polarity*/
#define MSTR 4	 /*Master/Slave Select*/
#define DORD 5	 /*Data Order*/
#define SPE 6	     /*SPI Enable*/
#define SPIE 7	 /*SPI Interrupt Enable*/

/*****ADDITIONAL WARNINGS*****************************/
#ifndef NEED_SPI_STANDART
#warning "SPI STANDART functions not added."
#endif
#ifndef NEED_SPI_SHORTYS
#warning "SPI SHORTY functions not added."
#endif
#ifndef NEED_SPI_DIRECTS
#warning "SPI DIRECT function not added."
#endif
#ifndef NEED_SPI_EXTENDED
#warning "SPI EXTENDED functions not added."
#endif


#endif
