/*
  Name: twi.S
  Copyright: TU-Berlin, IFFP, Remote Farm, Kai Scheddin
  Author: Kai Scheddin
  Date: 11.04.07 06:09
  Description: twi, or also called I2C io function's
*/


/*
Conditions:
START falling edge during a scl-high
stop a rising edge during a scl-high
restart same as start, but between start and stop



addy's:
All address packets transmitted on the TWI bus are nine bits long, 
consisting of seven
address bits, one READ/WRITE control bit and an acknowledge bit.


address 0000 000 is reserved for a generally call
address MSB is send first, LSB last, followed by a read write bit, 
the nith bit is the ACK bit, see page 170@ ATMEGA32.pdf, or another manual


An Acknowledge (ACK) is signalled by the receiver pulling the SDA line
low during the ninth SCL cycle.


The MSB of the data byte is sended first.

Note that arbitration is not allowed between:
 A REPEATED START condition and a data bit
 A STOP condition and a data bit
 A REPEATED START and a STOP condition

Note that the internal
pullups in the AVR pads can be enabled by setting the PORT bits corresponding to
the SCL and SDA pins, as explained in the I/O Port section. The internal pull-ups can in
some systems eliminate the need for external ones.

*/


#ifdef TWI_STANDART_INIT
.global twi_standart_init
.func twi_standart_init
twi_standart_init:
                  
                  
                  
.endfunc

.global twi_sendbyte
.func twi_sendbyte
twi_sendbyte:
             

.endfunc

.global twi_rcvbyte
.func twi_rcvbyte
twi_rcvbyte:
            
            
.endfunc


#endif
