/*
  Name: Usart_asm.asm, 
  Copyright: Kai (ZeuSOsC) Scheddin, 2007, 
  Author: Kai Scheddin        
  Date: 30.03.07 09:54
  Description: part of rem-controll v0.1

HINWEIS:
hier werden direkt auf register zugegriffen, und
es wird verzichtet sie im stack zu sichern,
bei recombilate und derer gleichen sollte dies bercksichtigt werden.
*/

#include "../config.h"
UCSRA=0x0b
UCSRB=0x0a
UCSRC=0x20
URSEL=7
UCSZ0=1
UCSZ1=2
UCsz2=2
UBRRH=0x20
UBRRL=0x09
UDR0=0	
UDR1=1	
UDR2=2	
UDR3=3	
UDR4=4	
UDR5=5	
UDR6=6	
UDR7=7	
UDRE=5
TXC=6	
RXC=7	
TXEN=3	
RXEN=4	
UDRIE=5	
TXCIE=6	
RXCIE=7	
UMSEL=6	
URSEL=7	
UDR=0x0c
/*;19200,8,n,1 by 16Mhz*/
.global usart_standart_init
.func usart_standart_init
usart_standart_init:
ldi r16,51
out UBRRL,r16
ldi r16,0x00
out UBRRH,r16
ldi r16, (1<<URSEL)|(3<<UCSZ0)	/*Frame-Format: 8 Bit*/
out UCSRC,r16
/*sbr UCSRB, RXCIE        ;Interrupt bei Empfang*/
in r16,UCSRB
sbr r16,TXEN
sbr r16,RXEN
out UCSRB,r16
ret
.endfunc


.global u_set_baud
.func u_set_baud
out UBRRL,r24
out UBRRH,r25


sbi UCSRB,RXEN         /*Empfang aktivieren*/
sbi UCSRB,TXEN          /*Senden aktivieren*/  

ret
.endfunc

.global u_set_rxd
.func u_enable_rxd
sbi UCSRB,RXEN         /*Empfang aktivieren*/
.endfunc

.global u_set_txd
.func u_set_txd
sbi UCSRB,TXEN          /*Senden aktivieren  */
.endfunc

.global u_set_int
.func u_set_int
sbi UCSRB,RXCIE        /*Interrupt bei Empfang*/
.endfunc

.global u_uset_rxd
.func u_enable_rxd
cbi UCSRB, RXEN         /*Empfang deaktivieren*/
.endfunc

.global u_uset_txd
.func u_set_txd
cbi UCSRB,TXEN         /*Senden deaktivieren*/
.endfunc

.global u_uset_int
.func u_set_int
cbi UCSRB,RXCIE        /*Empfang Interrupt deaktivieren*/
.endfunc


.global u_init
.func u_init
out UBRRL,r22         /*umrechnung manuell oder per c postcompilat*/
out UBRRH,r24
/*hier ohne sprungtabelle,.. muss ja net sein bei 4 varianten*/
mov r2,r16
clr r16
clr r17
in r16,UCSRC
in r17,UCSRB

sbr r16,URSEL

/*vielleicht mach ich noch ne sptere abfrage bzgl. a/synchronitt*/
/*setze auf asynchronitt*/
sbr r16,UMSEL /*UMSEL*/

/*paritt*/
cpi r18,'N'/*no*/
breq p1f
cpi r18,'n'
breq p1f
cpi r18,'O'/*odd*/
breq p2f
cpi r18,'o'
breq p2f
cpi r18,'E'/*even*/
breq p3f
cpi r18,'e'
breq p3f

p1:
cbr r16,4 /*UPM0 --US(A)RT Parity Mode Bit 0*/
cbr r16,5 /*UPM1 -- " 1"*/
rjmp p4f

p2:
cbr r16,4
sbr r16,5
rjmp p4f
	
p3:
sbr r16,4
sbr r16,5

p4:


/*stobbits*/
sbrs r2,2   
cbr r16,3
sbr r16,3

/*databits*/
cpi r20,5
breq 1f
cpi r20,6
breq 2f
cpi r20,7
breq 3f
cpi r20,8
breq 4f
cpi r20,9
breq 5f
brne 4f

1:
cbr r17,2
cbr r16,1
cbr r16,2
rjmp 6f

2:
cbr r17,2
sbr r16,1
cbr r16,2
rjmp 6f

3:
cbr r17,2
cbr r16,1
sbr r16,2
rjmp 6f

4:
cbr r17,2
sbr r16,1
sbr r16,2
rjmp 6f

5:
sbr r17,2
sbr r16,1
sbr r16,2

6:
out UCSRC,r16

sbr r17,RXEN        /*Empfang aktivieren*/
sbr r17,TXEN         /*Senden aktivieren*/  

out UCSRB,r17

ret
.endfunc

.global u_sendbyte
.func u_sendbyte
7:
/*  ; warten bis das UART bereit ist*/
sbis UCSRA,7
rjmp 7b
out UDR,r24

ret
.endfunc

.global u_non_blocking_sendbyte
.func u_non_blocking_sendbyte
out UDR,r24
ret
.endfunc

.global u_rcvbyte
.func u_rcvbyte
clr r24
8:
in r24,UDR
cpi r24,0
breq 8b
ret
.endfunc

.global u_non_blocking_rcv
.func u_non_blocking_rcv
in r24,UDR
ret
.endfunc




.end
